package fxKohtaushallinta;

import javafx.fxml.FXML;
import javafx.scene.control.Button;

import java.io.IOException;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import javafx.application.Platform;
import javafx.event.ActionEvent;
import javafx.scene.control.ComboBox;
import javafx.scene.control.Label;
import javafx.scene.control.MenuItem;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import kohtaushallinta.Kohtaushallinta;
import kohtaushallinta.Tietue;

/**
 * @author Jussi Lipitsäinen
 * @version 20.2.2025
 *
 */
public class KohtaushallintaGUIController {
    private Kohtaushallinta kh = new Kohtaushallinta();
    private int valittuIndeksi = 1;  // VÄLIAIKAINEN MUUTTUJA METODIEN TESTAAMISEKSI
    
    @FXML private Button btnAvaaKohtaus;
    @FXML private Button btnLisaaHahmo;
    @FXML private Button btnMuokkaaKohtausta;
    @FXML private Button btnMuokkaaValittua;
    @FXML private Button btnPoistaHahmo;
    @FXML private Button btnPoistaKohtaus;
    @FXML private Button btnSulje;
    @FXML private Button btnTallenna;
    @FXML private Button btnTuhoaValittu;
    @FXML private Button btnTyhjennaAsiaSuodatin;
    @FXML private Button btnTyhjennaHahmoSuodatin;
    @FXML private Button btnTyhjennaKohtausSuodattimet;
    @FXML private Button btnUusiKohtaus;
    @FXML private Label lblOtsikko;
    @FXML private MenuItem menuTallenna;
    @FXML private MenuItem menuUusiHahmo;
    @FXML private MenuItem menuUusiKohtaus;
    @FXML private TextArea txtAreaKohtausKuvaus;
    @FXML private TextArea txtAreaMuistiinpanot;
    @FXML private TextArea txtAreaValittu;
    @FXML private TextField txtKohtausSuodatin;
    @FXML private TextField txtSuodatinAsialista;
    @FXML private TextField txtSuodatinAsiat;
    @FXML private TextField txtSuodatinHahmolista;
    @FXML private TextField txtSuodatinHahmot;
    
    //TODO: Yhdistä luokkaobjekteiksi
    @FXML private ListChooser<?> lstChooserKohtaukset;
    @FXML private ListChooser<?> lstChooserHahmot;
    @FXML private ListChooser<?> lstChooserAsiat;
    @FXML private ListChooser<?> lstChooserHahmolista;
    @FXML private ListChooser<?> lstChooserAsialista;
    @FXML private ComboBox<?> cmbAsialistaAS;
    @FXML private ComboBox<?> cmbAsiatAS;
    @FXML private ComboBox<?> cmbHahmolistaAS;
    @FXML private ComboBox<?> cmbHahmotAS;
    @FXML private ComboBox<?> cmbKohtausAS;
    @FXML private MenuItem menuUusiAsia;
    @FXML private Button btnUusiAsia;
    @FXML private Button btnUusiHahmo;
    @FXML private Button btnTyhjennaSuodattimet1;
    @FXML private Button btnTyhjennaSuodattimet11;

    
    @FXML void handleAsiaAS() {
        paivitaAvainsana(cmbAsiatAS);
    }

    @FXML void handleAsialistanAS() {
        paivitaAvainsana(cmbAsialistaAS);
    }

    @FXML void handleAvaaKohtaus() {
        avaaKohtaus(valittuIndeksi);
    }

    @FXML void handleHahmoAS(ActionEvent event) {
        paivitaAvainsana(cmbHahmotAS);
    }

    @FXML void handleHahmolistanAS(ActionEvent event) {
        paivitaAvainsana(cmbHahmolistaAS);
    }

    @FXML void handleKohtausAS(ActionEvent event) {
        paivitaAvainsana(cmbKohtausAS);
    }

    @FXML void handleLisaaHahmo(ActionEvent event) {
        lisaaKohtaukseen(Kohtaushallinta.HAHMOT,valittuIndeksi);
    }

    @FXML void handleMuokkaaKohtausta(ActionEvent event) {
        //muokkaaTietuetta(Kohtaukset.KOHTAUS, valittuIndeksi);
    }

    @FXML void handleMuokkaaValittua() {
        //TODO hanki tieto, mikä valittu
        //muokkaaTietuetta(Kohtaukset.HAHMO, 0);
    }

    @FXML void handlePoistaHahmo() {
        //TODO hanki tieto, mikä valittu
        //poistaKohtauksesta(Kohtaukset.HAHMO, valittuIndeksi);
    }

    @FXML void handlePoistaKohtaus() {
        //tuhoaTietue(Kohtaukset.KOHTAUS, valittuIndeksi);
    }

    @FXML void handleSulje(ActionEvent event) {
        sulje();
    }

    @FXML void handleTallenna(ActionEvent event) {
        tallenna();
    }

    @FXML void handleTietueKlikkaus() {
        //
    }

    @FXML void handleTuhoaValittu() {
        //tuhoaTietue(Kohtaukset.HAHMO, valittuIndeksi);
    }

    @FXML void handleTyhjennaAsiaSuodatin() {
        //Tähän tyyliin tulevaisuudessa, paitsi yhdistävän luokan avulla:
        tyhjennaSuodatin(txtSuodatinAsiat);
    }

    @FXML void handleTyhjennaAsialistaSuodatin(ActionEvent event) {
        //Vaikka näin tulevaisuudessa:
        tyhjennaSuodatin(txtSuodatinAsialista);
    }

    @FXML void handleTyhjennaHahmoSuodatin(ActionEvent event) {
        tyhjennaSuodatin(txtSuodatinHahmot);
    }

    @FXML void handleTyhjennaHahmolistaSuodatin(ActionEvent event) {
        tyhjennaSuodatin(txtSuodatinHahmolista);
    }

    @FXML void handleTyhjennaKohtausSuodattimet(ActionEvent event) {
        tyhjennaSuodatin(txtKohtausSuodatin);
    }



    @FXML void handleUusiAsia(ActionEvent event) {
        uusiTietue(Kohtaushallinta.ASIAT);
    }

    @FXML void handleUusiHahmo(ActionEvent event) {
        uusiTietue(Kohtaushallinta.HAHMOT);
    }

    @FXML void handleUusiKohtaus(ActionEvent event) {
        uusiTietue(Kohtaushallinta.KOHTAUKSET);
    }
    
    @FXML void handlePoistaAsia() {
        poistaKohtauksesta(Kohtaushallinta.ASIAT, valittuIndeksi);
    }
    
    
    @FXML void handleUusiLista() {
        uusiLista();
    }
    
    @FXML void handleLataaLista() {
        lataaLista();
    }
    
    //=====================================================
    
    protected void alusta() {
        //
    }
    
    
    /**
     * Tallentaa tiedot ja sulkee ohjelman
     */
    private void sulje() {
        tallenna();
        Platform.exit();
    }
    
    /**
     * Avaa dialogin ladattavan listan valitsemiseksi
     */
    private void lataaLista() {
        Dialogs.showMessageDialog("Listan lataamista ei ole vielä toteutettu");
    }
    
    
    /*
     * Avaa dialogin uuden listan luomiseksi ja jos saa takaisin uuden listan, asettaa sen käsiteltäväksi. 
     */
    private void uusiLista() {
        Kohtaushallinta uusi = luoUusiLista();        
        if ( uusi != null ) { 
            try {
                uusi.lataa();
                kh = uusi;
            } catch (IllegalArgumentException ie) {
                Dialogs.showMessageDialog(ie.getMessage());
            } catch (IOException ie) {
                Dialogs.showMessageDialog(ie.getMessage());
            }
        }
    }
    
    
    /**
     * Poistaa halutun tietueen
     * @param tyyppi KOHTAUS, HAHMO, ASIA 
     * @param indeksi poistettavan indeksi
     */
    private void tuhoaTietue(int tyyppi, int indeksi) {
        Dialogs.showMessageDialog("Tietueen poistoa ei ole vielä toteutettu");
    }


    /**
     * Lisää kohtaukseen valitun tyyppisen tietueen tietystä indeksistä
     * @param tyyppi tietueen tyyppi
     * @param indeksi tietueen indeksi
     */
    private void lisaaKohtaukseen(int tyyppi, int indeksi) {
        Dialogs.showMessageDialog("Tietueen lisäämistä kohtaukseen ei ole vielä toteutettu");
    }
    
    
    private void muokkaaTietuetta(int tyyppi, int indeksi) {
        Tietue t = kh.get(tyyppi, indeksi);
        if (t == null) Dialogs.showMessageDialog("Tietuetta ei löytynyt");
        MuokkaaTietuettaController.muokkaaTietuetta(null, kh, t, indeksi);
    }
    
    /**
     * Poistaa tietueen kohtauksesta
     * @param tyyppi poistettavan tietueen tyyppi
     * @param indeksi poistettavan tietueen indeksi
     */
    private void poistaKohtauksesta(int tyyppi, int indeksi) {        
        Dialogs.showMessageDialog("Tietueen poistoa kohtauksesta ei ole vielä toteutettu");
    }
    
    /**
     * Tyhjentää valitun suodattimen
     * @param suodatin tyhjennettävä suodatin
     */
    private void tyhjennaSuodatin(TextField suodatin) {
        // TODO Muut toimenpiteet, muunna jutut luokaksi pelkän textfieldin sijaan
        suodatin.setText("");
    }
    
    /**
     * Päivittää avainsanat
     * @param avainsanat
     */
    private void paivitaAvainsana(ComboBox<?> avainsanat) {
        //TODO: Yhdistä jutut luokaksi
        Dialogs.showMessageDialog("Avainsanan päivitystä ei ole vielä toteutettu");
    }
    
    
    /**
     * Avaa valitun kohtauksen omaan ikkunaansa
     * @param indeksi valitun kohtauksen indeksi
     */
    public void avaaKohtaus(int indeksi) {       
        NaytaKohtausController.naytaKohtaus(kh, indeksi, null);
    }
    
    /**
     * Luo uuden tietueen haluttua tyyppiä
     * @param tyyppi KOHTAUS, HAHMO, ASIA
     */
    private void uusiTietue(int tyyppi) {
        Tietue uusi = kh.uusiTietue(tyyppi);
        if (uusi == null) Dialogs.showMessageDialog("Tietueen luomisessa tapahtui virhe.");
        MuokkaaTietuettaController.muokkaaTietuetta(null, kh, uusi, tyyppi );
    }
    
    
    /**
     * Luo uuden kohtauslistan
     * 
     */    
    private Kohtaushallinta luoUusiLista() {
        if (Dialogs.showQuestionDialog("Uusi lista", "Luodaan uusi kohtauslista, oletko varma?", "Kyllä", "En ole"))
            UusiKohtauslistaController.avaa(null);
        return null;
    }
    
    
    /**
     * Tallentaa tiedot levylle ja ilmoittaa onnistumisesta
     * @return true, jos tallennus onnistui ja muuten false
     */
    private boolean tallenna() {
        Dialogs.showMessageDialog("Tallennusta ei ole vielä toteutettu");
        return false;
    }
    
    
    private Tietue haeTietue(int tyyppi, int id) {
        return kh.get(tyyppi, id);
    }
    
      
}