package fxKohtaushallinta;

import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.stage.Stage;
import kohtaushallinta.Kohtaushallinta;
import kohtaushallinta.Tietue;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;

/**
 * @author Jussi Lipitsäinen
 * @version 21.3.2025
 * Muokkaa valitun tietueen tietoja.
 */
public class MuokkaaTietuettaController implements ModalControllerInterface<Tietue> {
    @FXML private Button btnLisaaAvainsana;
    @FXML private Button btnMuokkaa;
    @FXML private Button btnPeruuta;
    @FXML private Button btnPoista;
    @FXML private Button btnPoistaAvainsana;
    @FXML private Button btnSulje;
    @FXML private Button btnTallenna;
    @FXML private Button btnTyhjennaSuodattimet;
    @FXML private Button btnUusiTietue;
    @FXML private ComboBox<String> cmbAvainsanat;
    @FXML private ListChooser<?> lstChooser;
    @FXML private ListChooser<?> lstChooserTietueet;
    @FXML private TextArea txtAreaKuvaus;
    @FXML private TextField txtSuodatin;
    @FXML private TextField txtTietueenNimi;
    @FXML private TextField txtUusiAvainsana;
    
    private int tyyppi;

    
    @FXML void handleAvainsanaKlikkaus(MouseEvent event) {
        //
    }

    @FXML void handleLisaaAvainsana(ActionEvent event) {
        lisaaAvainsana();
    }

    @FXML void handleMuokkaa(ActionEvent event) {
        muokkaaTietuetta(0);
    }

    @FXML void handlePoista(ActionEvent event) {
        poistaTietue(0);
    }

    @FXML void handlePoistaAvainsana(ActionEvent event) {
        poistaAvainsana(0);
    }

    @FXML void handleTietueKlikkaus(MouseEvent event) {
        //
    }

    @FXML void handleTyhjennaSuodattimet(ActionEvent event) {
        tyhjennaSuodattimet();
    }

    @FXML void handlePeruuta(ActionEvent event) {
        peruuta();
    }

    @FXML void handleSulje(ActionEvent event) {
        sulje();
    }

    @FXML void handleTallenna(ActionEvent event) {
        tallenna();
    }

    @FXML void handleUusiTietue(ActionEvent event) {
        uusiTietue();
    }
    
    //============
    private Tietue valittu;
    
    
    /**
     * Tarkistaa tekstikentän sisällön ja lisää sen avainsanaksi, jos kelvollinen
     */
    public void lisaaAvainsana() {
        Dialogs.showMessageDialog("Avainsanan lisäämistä ei ole vielä toteutettu");
    }
    
    
    /**
     * Avaa uuden ikkunan ja luo uuden tietueen muokkaamista varten
     * @param modalityStage modaliteetti
     * @param kh kohtaushallinta
     * @param tyyppi tietueen tyyppi
     */
    public static void uusiTietue(Stage modalityStage, Kohtaushallinta kh, int tyyppi) {
        Tietue t = kh.uusiTietue(tyyppi);
        ModalController.showModal(KohtaushallintaGUIController.class.getResource("MuokkaaTietuetta.fxml"),
                "Tietue",
                modalityStage, t);
    }
    
    /**
     * Avaa ikkunan ja muokkaa valittua tietuetta
     * @param modalityStage modaliteetti
     * @param kh kohtaushallinta
     * @param tiet tietue
     * @param tyyppi tietueen tyyppi
     */
    public static void muokkaaTietuetta(Stage modalityStage, Kohtaushallinta kh, Tietue tiet, int tyyppi) {
        String otsikko;
        switch (tyyppi) {
            case Kohtaushallinta.KOHTAUKSET:
                otsikko = "Muokkaa kohtauksia";
                break;
            case Kohtaushallinta.HAHMOT:
                otsikko = "Muokkaa hahmoja";
                break;
            case Kohtaushallinta.ASIAT:
                otsikko = "Muokkaa asioita / esineitä";
                break;
            default:
                //TODO: VIRHE?
                return;
        }
        ModalController.showModal(KohtaushallintaGUIController.class.getResource("MuokkaaTietuetta.fxml"),
                otsikko,
                modalityStage, tiet);
    }
    

    @Override
    public Tietue getResult() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void handleShown() {
        // TODO Auto-generated method stub
    }
    


    @Override
    public void setDefault(Tietue oletus) {
        valittu = oletus;
        naytaTiedot(valittu);
    }
    
    
    public void naytaTiedot(Tietue t) {
        txtTietueenNimi.textProperty().setValue(t.getOtsikko());
        txtAreaKuvaus.textProperty().setValue(t.getKuvaus());
        cmbAvainsanat.setItems(t.getAvainsanat().getList());
    }
    
    
    
    //==================================================================
    //TODO: ORGANISOI UUSIKSI
    
    
    /**
     * Muokkaa valittua tietuetta
     * @param indeksi tietueen indeksi
     */
    private void muokkaaTietuetta(int indeksi) {
        Dialogs.showMessageDialog("Tietueen muokkaamista lisäämistä ei ole vielä toteutettu");
    }
    
    
    private void poistaTietue(int indeksi) {
        Dialogs.showMessageDialog("Tietueen poistoa ei ole vielä toteutettu");
    }
    
    
    
    private void poistaAvainsana(int indeksi) {
        Dialogs.showMessageDialog("Avainsanan poistoa ei ole vielä toteutettu");
    }
    
    
    private void uusiTietue() {
        Dialogs.showMessageDialog("Uutta tietuetta ei ole vielä toteutettu");
    }
    
    
    private void tallenna() {
        Dialogs.showMessageDialog("Tallennusta ei ole vielä toteutettu");
    }
    
    
    private void sulje() {
        Dialogs.showMessageDialog("Sulkemista ei ole vielä toteutettu");
    }
    
    
    private void peruuta() {
        Dialogs.showMessageDialog("Toimintojen peruuttamista ei ole vielä toteutettu");
    }
    
    
    private void tyhjennaSuodattimet() {
        txtSuodatin.setText("");
    }

}
