package kohtaushallinta;

import java.io.FileNotFoundException;

public class Linkkihallinta {
    private Linkit[] linkit= new Linkit[2];
    
    public static final int HAHMOT = 0;
    public static final int ASIAT = 1;    
    
    
    public Linkkihallinta() {
       this.linkit[0] = new Linkit();
       this.linkit[1] = new Linkit();
    }
    
    
    /**
     * Asettaa linkeille lähdetiedostot ja asettaa koon
     * @param koko linkkitaulukon koko
     * @param hahmolinkit Hahmotitueiden linkitysten tiedostonimi
     * @param asialinkit Asiatitueiden linkitysten tiedostonimi
     */
    public Linkkihallinta(int koko, String hahmolinkit, String asialinkit) {
        this.linkit[0] = new Linkit(koko, hahmolinkit);
        this.linkit[1] = new Linkit(koko, asialinkit);
    }
    
    
    /**
     * Lataa linkit tiedostoista
     * @throws FileNotFoundException Tiedostoa ei saada avattua
     */
    public void lataa() throws FileNotFoundException {
        this.linkit[0].lataa();
        this.linkit[1].lataa();
    }
    
    
    private Linkit getLinkit(int tyyppi) {
        switch (tyyppi) {
        case HAHMOT:
            return this.linkit[HAHMOT];
        case ASIAT:
            return this.linkit[ASIAT];
        default:
            return null; //TODO: VIRHEILMOITUS
        }
    }
    
    
    /**
     * Palauttaa tietueen ID:hen linkitetyt ID:t annetusta listasta
     * @param lista HAHMOT/ASIAT
     * @param id ID, johon linkitetyt ID:t haetaan
     * @return kokonaislukutaulukon, jossa ID:t. 
     */
    public int[] getLinkitetyt(int lista, int id) {        
        return getLinkit(lista).getIDt(id);
    }
}
